OpenTTD Source: X25519KeyExchangeOnlyServerHandler Class Reference

OpenTTD Source 15.0-beta1

Public Member Functions
X25519KeyExchangeOnlyServerHandler Class Reference

Server side handler for using X25519 without actual authentication. More...

`#include <network_crypto_internal.h>`

Inheritance diagram for X25519KeyExchangeOnlyServerHandler:

## Public Member Functions
| X25519KeyExchangeOnlyServerHandler (const X25519SecretKey &secret_key)
| Create the handler that that one does the key exchange.
virtual void | SendRequest (struct Packet &p) override
| Create the request to send to the client.
virtual ResponseResult | ReceiveResponse (struct Packet &p) override
| Read the response from the client.
virtual std::string_view | GetName () const override
| Get the name of the handler for debug messages.
virtual NetworkAuthenticationMethod | GetAuthenticationMethod () const override
| Get the method this handler is providing functionality for.
virtual bool | CanBeUsed () const override
| Checks whether this handler can be used with the current configuration.
virtual std::string | GetPeerPublicKey () const override
| Get the public key the peer provided during the authentication.
virtual void | SendEnableEncryption (struct Packet &p) override
| Create the request to enable encryption to the client.
virtual std::unique_ptr< NetworkEncryptionHandler > | CreateClientToServerEncryptionHandler () const override
| Create a NetworkEncryptionHandler to encrypt or decrypt messages from the client to the server.
virtual std::unique_ptr< NetworkEncryptionHandler > | CreateServerToClientEncryptionHandler () const override
| Create a NetworkEncryptionHandler to encrypt or decrypt messages from the server to the client.

## Additional Inherited Members
Public Types inherited from NetworkAuthenticationServerHandler
enum | ResponseResult { AUTHENTICATED , NOT_AUTHENTICATED , RETRY_NEXT_METHOD }
| The processing result of receiving a response. More...
Static Public Member Functions inherited from NetworkAuthenticationServerHandler
static std::unique_ptr< NetworkAuthenticationServerHandler > | Create (const NetworkAuthenticationPasswordProvider *password_provider, const NetworkAuthenticationAuthorizedKeyHandler *authorized_key_handler, NetworkAuthenticationMethodMask client_supported_method_mask=~static_cast< NetworkAuthenticationMethodMask >(0))
| Create a NetworkAuthenticationServerHandler.
Protected Types inherited from NetworkAuthenticationServerHandler
enum | ResponseResult { AUTHENTICATED , NOT_AUTHENTICATED , RETRY_NEXT_METHOD }
| The processing result of receiving a response. More...
Protected Member Functions inherited from X25519AuthenticationHandler
| X25519AuthenticationHandler (const X25519SecretKey &secret_key)
| Create the handler, and generate the public keys accordingly.
void | SendRequest (struct Packet &p)
bool | ReceiveRequest (struct Packet &p)
| Read the key exchange data from a `Packet` that came from the server,.
bool | SendResponse (struct Packet &p, std::string_view derived_key_extra_payload)
| Perform the key exchange, and when that is correct fill the `Packet` with the appropriate data.
NetworkAuthenticationServerHandler::ResponseResult | ReceiveResponse (struct Packet &p, std::string_view derived_key_extra_payload)
| Read the key exchange data from a `Packet` that came from the client, and check whether the client passes the key exchange successfully.
std::string | GetPeerPublicKey () const
| Get the public key the peer provided for the key exchange.
void | SendEnableEncryption (struct Packet &p) const
| Send the initial nonce for the encrypted connection.
bool | ReceiveEnableEncryption (struct Packet &p)
| Receive the initial nonce for the encrypted connection.
std::unique_ptr< NetworkEncryptionHandler > | CreateClientToServerEncryptionHandler () const
std::unique_ptr< NetworkEncryptionHandler > | CreateServerToClientEncryptionHandler () const
Static Protected Member Functions inherited from NetworkAuthenticationServerHandler
static std::unique_ptr< NetworkAuthenticationServerHandler > | Create (const NetworkAuthenticationPasswordProvider *password_provider, const NetworkAuthenticationAuthorizedKeyHandler *authorized_key_handler, NetworkAuthenticationMethodMask client_supported_method_mask=~static_cast< NetworkAuthenticationMethodMask >(0))
| Create a NetworkAuthenticationServerHandler.

## Detailed Description

Server side handler for using X25519 without actual authentication.

This follows the method described in `X25519AuthenticationHandler`, without an extra payload.

Definition at line 159 of file network_crypto_internal.h.

## Constructor & Destructor Documentation

## ◆ X25519KeyExchangeOnlyServerHandler()

X25519KeyExchangeOnlyServerHandler::X25519KeyExchangeOnlyServerHandler | ( | const X25519SecretKey & | secret_key | ) |
| inline

Create the handler that that one does the key exchange.

Parameters

  secret_key | The secret key to initialize this handler with.

Definition at line 165 of file network_crypto_internal.h.

## Member Function Documentation

## ◆ CanBeUsed()

virtual bool X25519KeyExchangeOnlyServerHandler::CanBeUsed | ( |  | ) | const
| inlineoverridevirtual

Checks whether this handler can be used with the current configuration.

For example when there is no password, the handler cannot be used.

Returns
  True when this handler can be used.

Implements NetworkAuthenticationServerHandler.

Definition at line 172 of file network_crypto_internal.h.

## ◆ CreateClientToServerEncryptionHandler()

virtual std::unique_ptr< NetworkEncryptionHandler > X25519KeyExchangeOnlyServerHandler::CreateClientToServerEncryptionHandler | ( |  | ) | const
| inlineoverridevirtual

Create a NetworkEncryptionHandler to encrypt or decrypt messages from the client to the server.

Returns
  The handler for the client to server encryption.

Implements NetworkAuthenticationHandler.

Definition at line 176 of file network_crypto_internal.h.

## ◆ CreateServerToClientEncryptionHandler()

virtual std::unique_ptr< NetworkEncryptionHandler > X25519KeyExchangeOnlyServerHandler::CreateServerToClientEncryptionHandler | ( |  | ) | const
| inlineoverridevirtual

Create a NetworkEncryptionHandler to encrypt or decrypt messages from the server to the client.

Returns
  The handler for the server to client encryption.

Implements NetworkAuthenticationHandler.

Definition at line 177 of file network_crypto_internal.h.

## ◆ GetAuthenticationMethod()

virtual NetworkAuthenticationMethod X25519KeyExchangeOnlyServerHandler::GetAuthenticationMethod | ( |  | ) | const
| inlineoverridevirtual

Get the method this handler is providing functionality for.

Returns
  The `NetworkAuthenticationMethod`.

Implements NetworkAuthenticationHandler.

Definition at line 171 of file network_crypto_internal.h.

References NETWORK_AUTH_METHOD_X25519_KEY_EXCHANGE_ONLY.

## ◆ GetName()

virtual std::string_view X25519KeyExchangeOnlyServerHandler::GetName | ( |  | ) | const
| inlineoverridevirtual

Get the name of the handler for debug messages.

Returns
  The name of the handler.

Implements NetworkAuthenticationHandler.

Definition at line 170 of file network_crypto_internal.h.

## ◆ GetPeerPublicKey()

virtual std::string X25519KeyExchangeOnlyServerHandler::GetPeerPublicKey | ( |  | ) | const
| inlineoverridevirtual

Get the public key the peer provided during the authentication.

Returns
  The hexadecimal string representation of the peer's public key.

Implements NetworkAuthenticationServerHandler.

Definition at line 174 of file network_crypto_internal.h.

References X25519AuthenticationHandler::GetPeerPublicKey().

## ◆ ReceiveResponse()

virtual ResponseResult X25519KeyExchangeOnlyServerHandler::ReceiveResponse | ( | struct Packet & | p | ) |
| inlineoverridevirtual

Read the response from the client.

Parameters

  p | The packet to read the response from.

Returns
  The `ResponseResult` describing the result.

Implements NetworkAuthenticationServerHandler.

Definition at line 168 of file network_crypto_internal.h.

References X25519AuthenticationHandler::ReceiveResponse().

## ◆ SendEnableEncryption()

virtual void X25519KeyExchangeOnlyServerHandler::SendEnableEncryption | ( | struct Packet & | p | ) |
| inlineoverridevirtual

Create the request to enable encryption to the client.

Parameters

  p | The packet to write the enable encryption request to.

Implements NetworkAuthenticationServerHandler.

Definition at line 175 of file network_crypto_internal.h.

References X25519AuthenticationHandler::SendEnableEncryption().

## ◆ SendRequest()

virtual void X25519KeyExchangeOnlyServerHandler::SendRequest | ( | struct Packet & | p | ) |
| inlineoverridevirtual

Create the request to send to the client.

Parameters

  p | The packet to write the request to.

Implements NetworkAuthenticationServerHandler.

Definition at line 167 of file network_crypto_internal.h.

The documentation for this class was generated from the following file:

- src/network/network_crypto_internal.h